diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/dsss-error-rate-model.h ns-3.43/src/wifi/model/non-ht/dsss-error-rate-model.h
--- ns-3.42/src/wifi/model/non-ht/dsss-error-rate-model.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/dsss-error-rate-model.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Gary Pei <guangyu.pei@boeing.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/dsss-parameter-set.cc ns-3.43/src/wifi/model/non-ht/dsss-parameter-set.cc
--- ns-3.42/src/wifi/model/non-ht/dsss-parameter-set.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/dsss-parameter-set.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/dsss-parameter-set.h ns-3.43/src/wifi/model/non-ht/dsss-parameter-set.h
--- ns-3.42/src/wifi/model/non-ht/dsss-parameter-set.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/dsss-parameter-set.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/dsss-phy.cc ns-3.43/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.42/src/wifi/model/non-ht/dsss-phy.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/dsss-phy.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
@@ -244,7 +233,7 @@
     return status;
 }
 
-uint16_t
+MHz_u
 DsssPhy::GetRxChannelWidth(const WifiTxVector& txVector) const
 {
     if (m_wifiPhy->GetChannelWidth() > 20)
@@ -260,23 +249,24 @@
     return PhyEntity::GetRxChannelWidth(txVector);
 }
 
-uint16_t
+MHz_u
 DsssPhy::GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const
 {
     return ppdu ? GetRxChannelWidth(ppdu->GetTxVector()) : 22;
 }
 
 Ptr<SpectrumValue>
-DsssPhy::GetTxPowerSpectralDensity(double txPowerW, Ptr<const WifiPpdu> ppdu) const
+DsssPhy::GetTxPowerSpectralDensity(Watt_u txPower, Ptr<const WifiPpdu> ppdu) const
 {
+    const auto& centerFrequencies = ppdu->GetTxCenterFreqs();
+    NS_ASSERT(centerFrequencies.size() == 1);
     const auto& txVector = ppdu->GetTxVector();
-    uint16_t centerFrequency = GetCenterFrequencyForChannelWidth(txVector);
-    uint16_t channelWidth = txVector.GetChannelWidth();
-    NS_LOG_FUNCTION(this << centerFrequency << channelWidth << txPowerW);
+    const auto channelWidth = txVector.GetChannelWidth();
+    NS_LOG_FUNCTION(this << centerFrequencies.front() << channelWidth << txPower);
     NS_ABORT_MSG_IF(channelWidth != 22, "Invalid channel width for DSSS");
-    Ptr<SpectrumValue> v =
-        WifiSpectrumValueHelper::CreateDsssTxPowerSpectralDensity(centerFrequency,
-                                                                  txPowerW,
+    auto v =
+        WifiSpectrumValueHelper::CreateDsssTxPowerSpectralDensity(centerFrequencies.front(),
+                                                                  txPower,
                                                                   GetGuardBandwidth(channelWidth));
     return v;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/dsss-phy.h ns-3.43/src/wifi/model/non-ht/dsss-phy.h
--- ns-3.42/src/wifi/model/non-ht/dsss-phy.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/dsss-phy.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
@@ -160,10 +149,10 @@
 
   private:
     PhyFieldRxStatus DoEndReceiveField(WifiPpduField field, Ptr<Event> event) override;
-    Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
+    Ptr<SpectrumValue> GetTxPowerSpectralDensity(Watt_u txPower,
                                                  Ptr<const WifiPpdu> ppdu) const override;
-    uint16_t GetRxChannelWidth(const WifiTxVector& txVector) const override;
-    uint16_t GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
+    MHz_u GetRxChannelWidth(const WifiTxVector& txVector) const override;
+    MHz_u GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
 
     /**
      * \param txVector the transmission parameters
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/dsss-ppdu.cc ns-3.43/src/wifi/model/non-ht/dsss-ppdu.cc
--- ns-3.42/src/wifi/model/non-ht/dsss-ppdu.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/dsss-ppdu.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/dsss-ppdu.h ns-3.43/src/wifi/model/non-ht/dsss-ppdu.h
--- ns-3.42/src/wifi/model/non-ht/dsss-ppdu.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/dsss-ppdu.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/erp-information.cc ns-3.43/src/wifi/model/non-ht/erp-information.cc
--- ns-3.42/src/wifi/model/non-ht/erp-information.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/erp-information.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2015 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/erp-information.h ns-3.43/src/wifi/model/non-ht/erp-information.h
--- ns-3.42/src/wifi/model/non-ht/erp-information.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/erp-information.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2015 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/erp-ofdm-phy.cc ns-3.43/src/wifi/model/non-ht/erp-ofdm-phy.cc
--- ns-3.42/src/wifi/model/non-ht/erp-ofdm-phy.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/erp-ofdm-phy.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
@@ -208,7 +197,7 @@
 }
 
 uint64_t
-ErpOfdmPhy::GetPhyRate(const std::string& name, uint16_t channelWidth)
+ErpOfdmPhy::GetPhyRate(const std::string& name, MHz_u channelWidth)
 {
     WifiCodeRate codeRate = GetCodeRate(name);
     uint16_t constellationSize = GetConstellationSize(name);
@@ -229,7 +218,7 @@
 }
 
 uint64_t
-ErpOfdmPhy::GetDataRate(const std::string& name, uint16_t channelWidth)
+ErpOfdmPhy::GetDataRate(const std::string& name, MHz_u channelWidth)
 {
     WifiCodeRate codeRate = GetCodeRate(name);
     uint16_t constellationSize = GetConstellationSize(name);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/erp-ofdm-phy.h ns-3.43/src/wifi/model/non-ht/erp-ofdm-phy.h
--- ns-3.42/src/wifi/model/non-ht/erp-ofdm-phy.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/erp-ofdm-phy.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
@@ -145,11 +134,11 @@
      * and is mainly used as a callback for WifiMode operation.
      *
      * \param name the unique name of the ERP-OFDM mode
-     * \param channelWidth the considered channel width in MHz
+     * \param channelWidth the considered channel width
      *
      * \return the physical bit rate of this signal in bps.
      */
-    static uint64_t GetPhyRate(const std::string& name, uint16_t channelWidth);
+    static uint64_t GetPhyRate(const std::string& name, MHz_u channelWidth);
     /**
      * Return the PHY rate corresponding to
      * the supplied TXVECTOR.
@@ -178,11 +167,11 @@
      * and is mainly used as a callback for WifiMode operation.
      *
      * \param name the unique name of the ERP-OFDM mode
-     * \param channelWidth the considered channel width in MHz
+     * \param channelWidth the considered channel width
      *
      * \return the data bit rate of this signal in bps.
      */
-    static uint64_t GetDataRate(const std::string& name, uint16_t channelWidth);
+    static uint64_t GetDataRate(const std::string& name, MHz_u channelWidth);
     /**
      * Check whether the combination in TXVECTOR is allowed.
      * This function is used as a callback for WifiMode operation.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/erp-ofdm-ppdu.cc ns-3.43/src/wifi/model/non-ht/erp-ofdm-ppdu.cc
--- ns-3.42/src/wifi/model/non-ht/erp-ofdm-ppdu.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/erp-ofdm-ppdu.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/erp-ofdm-ppdu.h ns-3.43/src/wifi/model/non-ht/erp-ofdm-ppdu.h
--- ns-3.42/src/wifi/model/non-ht/erp-ofdm-ppdu.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/erp-ofdm-ppdu.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/ofdm-phy.cc ns-3.43/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.42/src/wifi/model/non-ht/ofdm-phy.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/ofdm-phy.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
@@ -80,8 +69,8 @@
     { "OfdmRate13_5MbpsBW5MHz", { WIFI_CODE_RATE_3_4, 64 } }
 };
 
-/// OFDM rates in bits per second for each bandwidth (MHz)
-const std::map<uint16_t, std::array<uint64_t, 8> > s_ofdmRatesBpsList =
+/// OFDM rates in bits per second for each bandwidth
+const std::map<MHz_u, std::array<uint64_t, 8> > s_ofdmRatesBpsList =
    {{ 20, // MHz
      {  6000000,  9000000, 12000000, 18000000,
        24000000, 36000000, 48000000, 54000000 }},
@@ -96,11 +85,11 @@
 // clang-format on
 
 /**
- * Get the array of possible OFDM rates for each bandwidth (MHz).
+ * Get the array of possible OFDM rates for each bandwidth.
  *
  * \return the OFDM rates in bits per second
  */
-const std::map<uint16_t, std::array<uint64_t, 8>>&
+const std::map<MHz_u, std::array<uint64_t, 8>>&
 GetOfdmRatesBpsList()
 {
     return s_ofdmRatesBpsList;
@@ -168,7 +157,7 @@
 WifiMode
 OfdmPhy::GetHeaderMode(const WifiTxVector& txVector) const
 {
-    switch (txVector.GetChannelWidth())
+    switch (static_cast<uint16_t>(txVector.GetChannelWidth()))
     {
     case 5:
         return GetOfdmRate1_5MbpsBW5MHz();
@@ -207,7 +196,7 @@
 Time
 OfdmPhy::GetPreambleDuration(const WifiTxVector& txVector) const
 {
-    switch (txVector.GetChannelWidth())
+    switch (static_cast<uint16_t>(txVector.GetChannelWidth()))
     {
     case 20:
     default:
@@ -231,7 +220,7 @@
 Time
 OfdmPhy::GetHeaderDuration(const WifiTxVector& txVector) const
 {
-    switch (txVector.GetChannelWidth())
+    switch (static_cast<uint16_t>(txVector.GetChannelWidth()))
     {
     case 20:
     default:
@@ -344,7 +333,7 @@
 bool
 OfdmPhy::IsChannelWidthSupported(Ptr<const WifiPpdu> ppdu) const
 {
-    uint16_t channelWidth = ppdu->GetTxVector().GetChannelWidth();
+    const auto channelWidth = ppdu->GetTxVector().GetChannelWidth();
     if ((channelWidth >= 40) && (channelWidth > m_wifiPhy->GetChannelWidth()))
     {
         NS_LOG_DEBUG("Packet reception could not be started because not enough channel width ("
@@ -365,20 +354,20 @@
 }
 
 Ptr<SpectrumValue>
-OfdmPhy::GetTxPowerSpectralDensity(double txPowerW, Ptr<const WifiPpdu> ppdu) const
+OfdmPhy::GetTxPowerSpectralDensity(Watt_u txPower, Ptr<const WifiPpdu> ppdu) const
 {
+    const auto& centerFrequencies = ppdu->GetTxCenterFreqs();
     const auto& txVector = ppdu->GetTxVector();
-    uint16_t centerFrequency = GetCenterFrequencyForChannelWidth(txVector);
-    uint16_t channelWidth = txVector.GetChannelWidth();
-    NS_LOG_FUNCTION(this << centerFrequency << channelWidth << txPowerW);
+    const auto channelWidth = txVector.GetChannelWidth();
+    NS_LOG_FUNCTION(this << centerFrequencies.front() << channelWidth << txPower);
     const auto& txMaskRejectionParams = GetTxMaskRejectionParams();
     Ptr<SpectrumValue> v;
     if (txVector.IsNonHtDuplicate())
     {
         v = WifiSpectrumValueHelper::CreateDuplicated20MhzTxPowerSpectralDensity(
-            centerFrequency,
+            centerFrequencies,
             channelWidth,
-            txPowerW,
+            txPower,
             GetGuardBandwidth(channelWidth),
             std::get<0>(txMaskRejectionParams),
             std::get<1>(txMaskRejectionParams),
@@ -386,10 +375,11 @@
     }
     else
     {
+        NS_ASSERT(centerFrequencies.size() == 1);
         v = WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity(
-            centerFrequency,
+            centerFrequencies.front(),
             channelWidth,
-            txPowerW,
+            txPower,
             GetGuardBandwidth(channelWidth),
             std::get<0>(txMaskRejectionParams),
             std::get<1>(txMaskRejectionParams),
@@ -411,9 +401,9 @@
 }
 
 WifiMode
-OfdmPhy::GetOfdmRate(uint64_t rate, uint16_t bw)
+OfdmPhy::GetOfdmRate(uint64_t rate, MHz_u bw)
 {
-    switch (bw)
+    switch (static_cast<uint16_t>(bw))
     {
     case 20:
         switch (rate)
@@ -560,7 +550,7 @@
 }
 
 uint64_t
-OfdmPhy::GetPhyRate(const std::string& name, uint16_t channelWidth)
+OfdmPhy::GetPhyRate(const std::string& name, MHz_u channelWidth)
 {
     WifiCodeRate codeRate = GetCodeRate(name);
     uint64_t dataRate = GetDataRate(name, channelWidth);
@@ -604,7 +594,7 @@
 }
 
 uint64_t
-OfdmPhy::GetDataRate(const std::string& name, uint16_t channelWidth)
+OfdmPhy::GetDataRate(const std::string& name, MHz_u channelWidth)
 {
     WifiCodeRate codeRate = GetCodeRate(name);
     uint16_t constellationSize = GetConstellationSize(name);
@@ -612,7 +602,7 @@
 }
 
 uint64_t
-OfdmPhy::CalculateDataRate(WifiCodeRate codeRate, uint16_t constellationSize, uint16_t channelWidth)
+OfdmPhy::CalculateDataRate(WifiCodeRate codeRate, uint16_t constellationSize, MHz_u channelWidth)
 {
     return CalculateDataRate(GetSymbolDuration(channelWidth),
                              GetUsableSubcarriers(),
@@ -637,7 +627,7 @@
 }
 
 Time
-OfdmPhy::GetSymbolDuration(uint16_t channelWidth)
+OfdmPhy::GetSymbolDuration(MHz_u channelWidth)
 {
     Time symbolDuration = MicroSeconds(4);
     uint8_t bwFactor = 1;
@@ -664,24 +654,24 @@
     return 4095;
 }
 
-uint16_t
+MHz_u
 OfdmPhy::GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const
 {
     if (!ppdu)
     {
-        return 20;
+        return std::min<MHz_u>(m_wifiPhy->GetChannelWidth(), 20);
     }
     return GetRxChannelWidth(ppdu->GetTxVector());
 }
 
-double
+dBm_u
 OfdmPhy::GetCcaThreshold(const Ptr<const WifiPpdu> ppdu, WifiChannelListType channelType) const
 {
     if (ppdu && ppdu->GetTxVector().GetChannelWidth() < 20)
     {
         // scale CCA sensitivity threshold for BW of 5 and 10 MHz
-        uint16_t bw = GetRxChannelWidth(ppdu->GetTxVector());
-        double thresholdW = DbmToW(m_wifiPhy->GetCcaSensitivityThreshold()) * (bw / 20.0);
+        const auto bw = GetRxChannelWidth(ppdu->GetTxVector());
+        const auto thresholdW = DbmToW(m_wifiPhy->GetCcaSensitivityThreshold()) * (bw / 20.0);
         return WToDbm(thresholdW);
     }
     return PhyEntity::GetCcaThreshold(ppdu, channelType);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/ofdm-phy.h ns-3.43/src/wifi/model/non-ht/ofdm-phy.h
--- ns-3.42/src/wifi/model/non-ht/ofdm-phy.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/ofdm-phy.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
@@ -87,8 +76,8 @@
     Ptr<WifiPpdu> BuildPpdu(const WifiConstPsduMap& psdus,
                             const WifiTxVector& txVector,
                             Time ppduDuration) override;
-    double GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
-                           WifiChannelListType channelType) const override;
+    dBm_u GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
+                          WifiChannelListType channelType) const override;
     Ptr<const WifiPpdu> GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu) override;
 
     /**
@@ -101,10 +90,10 @@
      * the channel bandwidth (20, 10, or 5 MHz).
      *
      * \param rate the rate in bps
-     * \param bw the bandwidth in MHz
+     * \param bw the bandwidth
      * \return a WifiMode for OFDM
      */
-    static WifiMode GetOfdmRate(uint64_t rate, uint16_t bw = 20);
+    static WifiMode GetOfdmRate(uint64_t rate, MHz_u bw = 20);
     /**
      * Return a WifiMode for OFDM at 6 Mbps.
      *
@@ -274,11 +263,11 @@
      * and is mainly used as a callback for WifiMode operation.
      *
      * \param name the unique name of the OFDM mode
-     * \param channelWidth the considered channel width in MHz
+     * \param channelWidth the considered channel width
      *
      * \return the physical bit rate of this signal in bps.
      */
-    static uint64_t GetPhyRate(const std::string& name, uint16_t channelWidth);
+    static uint64_t GetPhyRate(const std::string& name, MHz_u channelWidth);
 
     /**
      * Return the PHY rate corresponding to
@@ -308,11 +297,11 @@
      * is mainly used as a callback for WifiMode operation.
      *
      * \param name the unique name of the OFDM mode
-     * \param channelWidth the considered channel width in MHz
+     * \param channelWidth the considered channel width
      *
      * \return the data bit rate of this signal in bps.
      */
-    static uint64_t GetDataRate(const std::string& name, uint16_t channelWidth);
+    static uint64_t GetDataRate(const std::string& name, MHz_u channelWidth);
     /**
      * Check whether the combination in TXVECTOR is allowed.
      * This function is used as a callback for WifiMode operation.
@@ -324,10 +313,10 @@
 
   protected:
     PhyFieldRxStatus DoEndReceiveField(WifiPpduField field, Ptr<Event> event) override;
-    Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
+    Ptr<SpectrumValue> GetTxPowerSpectralDensity(Watt_u txPower,
                                                  Ptr<const WifiPpdu> ppdu) const override;
     uint32_t GetMaxPsduSize() const override;
-    uint16_t GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
+    MHz_u GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
 
     /**
      * \param txVector the transmission parameters
@@ -404,13 +393,13 @@
      *
      * \param codeRate the code rate of the mode
      * \param constellationSize the size of modulation constellation
-     * \param channelWidth the considered channel width in MHz
+     * \param channelWidth the considered channel width
      *
      * \return the data bit rate of this signal in bps.
      */
     static uint64_t CalculateDataRate(WifiCodeRate codeRate,
                                       uint16_t constellationSize,
-                                      uint16_t channelWidth);
+                                      MHz_u channelWidth);
     /**
      * Calculates data rate from the supplied parameters.
      *
@@ -432,10 +421,10 @@
     static uint16_t GetUsableSubcarriers();
 
     /**
-     * \param channelWidth the channel width in MHz
+     * \param channelWidth the channel width
      * \return the symbol duration
      */
-    static Time GetSymbolDuration(uint16_t channelWidth);
+    static Time GetSymbolDuration(MHz_u channelWidth);
 
   private:
     /**
